'use strict';

/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeThemeProvider = require('nuke-theme-provider');

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _material = require('./view/material');

var _material2 = _interopRequireDefault(_material);

var _normal = require('./view/normal');

var _normal2 = _interopRequireDefault(_normal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_Component) {
  _inherits(Input, _Component);

  function Input(props, context) {
    _classCallCheck(this, Input);

    var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props));

    _this.focus = _this.focus.bind(_this);
    _this.blur = _this.blur.bind(_this);
    _this.clear = _this.blur.bind(_this);
    _this.getRef = _this.getRef.bind(_this);
    _this.getValue = _this.getValue.bind(_this);
    _this.materialDesign = context.androidConfigs && context.androidConfigs.materialDesign;
    if ('materialDesign' in props) {
      _this.materialDesign = props.materialDesign;
    }
    return _this;
  }

  _createClass(Input, [{
    key: 'focus',
    value: function focus() {
      this.refs.baseinput.focus();
    }
  }, {
    key: 'blur',
    value: function blur() {
      this.refs.baseinput.blur();
    }
  }, {
    key: 'clear',
    value: function clear() {
      this.refs.baseinput.clear();
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      return this.refs.baseinput.getValue();
    }
  }, {
    key: 'getRef',
    value: function getRef() {
      return this.refs.baseinput.getRef();
    }
  }, {
    key: 'render',
    value: function render() {
      return this.materialDesign ? (0, _rax.createElement)(_material2.default, _extends({ ref: 'baseinput' }, this.props)) : (0, _rax.createElement)(_normal2.default, _extends({ ref: 'baseinput' }, this.props));
    }
  }]);

  return Input;
}(_rax.Component);

Input.contextTypes = {
  androidConfigs: _rax.PropTypes.any,
  commonConfigs: _rax.PropTypes.any
};
Input.displayName = 'Input';
var StyledInput = (0, _nukeThemeProvider.connectStyle)(_styles2.default, { withRef: true })(Input);

exports.default = StyledInput;
module.exports = exports['default'];